﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using System.Windows.Threading;
using Infragistics.Windows.Controls;
using System.ComponentModel;
using System.Diagnostics;

namespace SampleApp
{
  /// <summary>
  /// Interaction logic for Window1.xaml
  /// </summary>
  public partial class Window1 : Window
  {
    private CustomerDataSet _currentDataSet;
    public Window1()
    {
      InitializeComponent();
      RecordContainerGenerationMode = Infragistics.Windows.Controls.ItemContainerGenerationMode.Recycle;
      CellContainerGenerationMode = CellContainerGenerationMode.Recycle;
      RecordLoadMode = RecordLoadMode.PreloadRecords;
      _grid.RecordContainerGenerationMode = Infragistics.Windows.Controls.ItemContainerGenerationMode.Recycle;
      _grid.CellContainerGenerationMode = CellContainerGenerationMode.Recycle;
      _grid.RecordLoadMode = RecordLoadMode.LoadOnDemand;
      this.DataContext = this;
    }


    private void Button1_Click(object sender, RoutedEventArgs e)
    {
      DisposeDataSet();
      _grid.DataContext = null; 
      _grid.RecordContainerGenerationMode = RecordContainerGenerationMode;
      _grid.CellContainerGenerationMode = CellContainerGenerationMode;
      _currentDataSet = new CustomerDataSet(true);
      _grid.DataSource = _currentDataSet.Customer.DefaultView; 
    }


    private void Button2_Click(object sender, RoutedEventArgs e)
    {
      DisposeDataSet();
      _grid.DataContext = null; 
      _grid.RecordContainerGenerationMode = RecordContainerGenerationMode;
      _grid.CellContainerGenerationMode = CellContainerGenerationMode;
      _grid.RecordLoadMode = RecordLoadMode;
      _currentDataSet = new CustomerDataSet(false);
      _grid.DataSource = _currentDataSet.Customer.DefaultView; 
    }

    private void Button3_Click(object sender, RoutedEventArgs e)
    {
      DisposeDataSet();
      _grid.DataSource = null;
    }

    private void DisposeDataSet()
    {
      if(_currentDataSet != null)
      {
        _currentDataSet.Dispose();
      }
    }

    public IEnumerable<RecordLoadMode> RecordLoadModes
    {
      get { return Enum.GetValues(typeof(RecordLoadMode)).Cast<RecordLoadMode>(); }
    }

    public IEnumerable<ItemContainerGenerationMode> RecordContainerGenerationModes
    {
      get { return Enum.GetValues(typeof(ItemContainerGenerationMode)).Cast<ItemContainerGenerationMode>(); }
    }

    public IEnumerable<CellContainerGenerationMode> CellContainerGenerationModes
    {
      get { return Enum.GetValues(typeof(CellContainerGenerationMode)).Cast<CellContainerGenerationMode>(); }
    }

    public RecordLoadMode _recordLoadMode;
    public RecordLoadMode RecordLoadMode
    {
      get { return _recordLoadMode; }
      set { _recordLoadMode = value; }
    }

    public CellContainerGenerationMode _CellContainerGenerationMode;
    public CellContainerGenerationMode CellContainerGenerationMode
    {
      get { return _CellContainerGenerationMode; }
      set { _CellContainerGenerationMode = value; }
    }

    public ItemContainerGenerationMode _RecordContainerGenerationMode;
    public ItemContainerGenerationMode RecordContainerGenerationMode
    {
      get { return _RecordContainerGenerationMode; }
      set { _RecordContainerGenerationMode = value; }
    }
  }
}